package com.cf.imes.module.system.service.process;

import com.cf.imes.module.system.controller.admin.process.vo.process.*;
import com.cf.imes.module.system.dal.dataobject.process.ProcessDO;
import com.cf.imes.framework.common.pojo.PageResult;

import javax.validation.Valid;
import java.util.List;

/**
 * 工序信息表 process Service 接口
 *
 * @author 晨丰科技
 */
public interface ProcessService {

    /**
     * 创建工序信息表 process
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProcess(@Valid ProcessUserSaveReqVO createReqVO);

    /**
     * 更新工序信息表 process
     *
     * @param updateReqVO 更新信息
     */
    void updateProcess(@Valid ProcessUserSaveReqVO updateReqVO);

    /**
     * 删除工序信息表 process
     *
     * @param id 编号
     */
    void deleteProcess(Long id);

    /**
     * 获得工序信息表 process
     *
     * @param id 编号
     * @return 工序信息表 process
     */
    ProcessUserRespVO getProcess(Long id);

    /**
     * 获得工序信息表 process分页
     *
     * @param pageReqVO 分页查询
     * @return 工序信息表 process分页
     */
    PageResult<ProcessDO> getProcessPage(ProcessPageReqVO pageReqVO);

    /**
     * 获得工序信息表 process分页
     *
     * @param pageReqVO 分页查询
     * @return 工序信息表 process分页
     */
    PageResult<ProcessRespVO> getProcessPageAll(ProcessPageReqVO pageReqVO);

    /**
     * 获得所有工序信息表 process
     *
     * @return 工序信息表 process
     */
    List<ProcessDO> getAllProcess();

    List<ProcessDO> getUserProcess(Long userId);
}